import { Meta, Story, Canvas, Description } from '@storybook/addon-docs/blocks';
import readme from './readme.md';

<Meta title="Media/digi-media-image" parameters={{ actions: { handles: ['afOnLoad'] } }} />

<!-- Description pulled from auto generated Stencil docs -->

<Description markdown={readme} />

## Standard

This is the standard image component. It defaults to lazy loading the image.

<Canvas>
  <Story name="Standard">
    /* html */
    {`
      <digi-media-image
        af-src="https://picsum.photos/id/237/1280/720"
        af-alt="En bild"
        af-width="1280"
        af-height="720"
      ></digi-media-image>
      <p>I am content below the image, but should not repaint because of the padded box.</p>
    `}
  </Story>
</Canvas>

## With Srcset

The image can also have a `srcset`, which takes precedence over `src`.

<Canvas>
  <Story name="With Caption">
    /* html */
    {`
      <digi-media-image
        af-src="https://picsum.photos/id/237/1280/720"
        af-srcset="https://picsum.photos/id/238/1280/720"
        af-alt="En bild"
        af-width="1280"
        af-height="720"
      ></digi-media-image>
      <p>This image has a srcset that takes precedence over src.</p>
    `}
  </Story>
</Canvas>

## Unlazy

If you need to disable lazy loading, set `af-unlazy` to true.

<Canvas>
  <Story name="Unlazy">
    /* html */
    {`
      <digi-media-image
        af-src="https://picsum.photos/id/237/1280/720"
        af-alt="En bild"
        af-width="1280"
        af-height="720"
        af-unlazy
      ></digi-media-image>
      <p>This image is not lazy loaded.</p>
    `}
  </Story>
</Canvas>

## No Width And Height

If no width and height are provided, the component can't calculate its expected box size, and will make the page repaint on load.

<Canvas>
  <Story name="No Width And Height">
    /* html */
    {`
      <digi-media-image
        af-src="https://picsum.photos/id/237/1280/720"
        af-alt="En bild"
      ></digi-media-image>
      <p>This image has no set width and height, which makes the page repaint on load.</p>
    `}
  </Story>
</Canvas>
